<template>
  <v-main>
    <v-alert v-if="showError" type="error">{{ errorText }}</v-alert>
    <v-container style="padding-top: 17%">
      <v-spacer></v-spacer>
      <v-row>
        <v-col><v-spacer></v-spacer></v-col>
        <v-col>
          <v-card>
            <v-card-title>Unreal+VA Streaming Dashboard</v-card-title>
            <v-card-subtitle>Login</v-card-subtitle>
            <v-card-text>
              <v-text-field v-model="username" label="Username"></v-text-field>
              <v-text-field
                v-model="password"
                label="Password"
                type="password"
              ></v-text-field>
            </v-card-text>
            <v-card-actions>
              <v-btn
                :disabled="loading"
                :loading="loading"
                color="green"
                @click="login"
                >Login</v-btn
              >
            </v-card-actions>
          </v-card>
        </v-col>
        <v-col><v-spacer></v-spacer></v-col>
      </v-row>
    </v-container>
  </v-main>
</template>

<script lang="ts">
import Vue from "vue";
import axios from "axios";

export default Vue.extend({
  name: "App",
  mounted() {
    window.addEventListener("keyup", (event) => {
      if (event.key === "Enter") {
        this.login();
      }
    });
  },
  computed: {
    showError: function () {
      return this.error;
    },
  },
  data: () => {
    return {
      username: "",
      password: "",
      error: false,
      loading: false,
      errorText: "",
    };
  },
  methods: {
    login: function () {
      this.loading = true;
      axios
        .post("http://localhost:7273/login", {
          user: this.username,
          password: this.password,
        })
        .then((res) => {
          if (!res.data.success) {
            this.error = true;
            res.data.message
              ? (this.errorText = res.data.message)
              : (this.errorText = "An unexpected error occured..");
            this.loading = false;
          } else {
            this.loading = false;
            this.$router.push("/home");
          }
        })
        .catch((err) => {
          this.error = true;
          this.loading = false;
          this.errorText = "An error occured: " + err;
        });
    },
  },
});
</script>
